const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const product_color_sets = sequelize.define(
    'product_color_sets',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

set_name: {
        type: DataTypes.TEXT,
      
      

      },

total_colors: {
        type: DataTypes.INTEGER,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  product_color_sets.associate = (db) => {

    db.product_color_sets.belongsToMany(db.paint_colors, {
      as: 'colors',
      foreignKey: {
        name: 'product_color_sets_colorsId',
      },
      constraints: false,
      through: 'product_color_setsColorsPaint_colors',
    });

    db.product_color_sets.belongsToMany(db.paint_colors, {
      as: 'colors_filter',
      foreignKey: {
        name: 'product_color_sets_colorsId',
      },
      constraints: false,
      through: 'product_color_setsColorsPaint_colors',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.product_color_sets.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });




    db.product_color_sets.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.product_color_sets.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return product_color_sets;
};


